"use strict";
const toString = Object.prototype.toString;



function isURL(url)
{
	// Speed optimization
	if (url == null) return false;

	// Native implementation
	if (toString.call(url) === "[object URL]") return true;

	if (typeof url !== "object") return false;
	
	if (!("href"     in url)) return false;
	if (!("protocol" in url)) return false;
	if (!("username" in url)) return false;
	if (!("password" in url)) return false;
	if (!("hostname" in url)) return false;
	if (!("port"     in url)) return false;
	if (!("host"     in url)) return false;
	if (!("pathname" in url)) return false;
	if (!("search"   in url)) return false;
	if (!("hash"     in url)) return false;
	
	// Polyfill implementation
	return true;
}



module.exports = isURL;
